%global momorel 4

%if %{?WITH_SELINUX:0}%{!?WITH_SELINUX:1}
%define WITH_SELINUX 1
%endif
%if %{?WITH_PAM:0}%{!?WITH_PAM:1}
%define WITH_PAM 1
%endif
%if %{?WITH_AUDIT:0}%{!?WITH_AUDIT:1}
%define WITH_AUDIT 1
%endif
Summary: The Vixie cron daemon for executing specified programs at set times.
Name: vixie-cron
Version: 4.1
Release: %{momorel}m
License: see "README"
Group: System Environment/Base
Source0: ftp://ftp.isc.org/isc/cron/vixie-cron-%{version}.tar.gz
Source1: vixie-cron.init
Source2: crond.sysconfig
Patch0:  vixie-cron-4.1-_0_rh_Makefile.patch
Patch1:  vixie-cron-4.1-_1_rh_pathnames.patch
Patch2:  vixie-cron-4.1-_2_config.patch
Patch3:  vixie-cron-4.1-_3_selinux.patch
Patch4:  vixie-cron-4.1-_4_vfork_sigchld.patch
Patch5:  vixie-cron-4.1-_5_sprintf_misc.patch
Patch6:  vixie-cron-4.1-_6_rh_crond.patch
Patch7:  vixie-cron-4.1-_7_crontab-stdin.patch
Patch8:  vixie-cron-4.1-_8_root-allowed.patch
Patch9:  vixie-cron-4.1-_9_no-header.patch
Patch10: vixie-cron-4.1-_10_manpages.patch
Patch11: vixie-cron-4.1-_11_with_selinux.patch
Patch12: vixie-cron-4.1-_12_pam.patch
Patch13: vixie-cron-4.1-_13_with_pam.patch
Patch14: vixie-cron-4.1-_14_pamd_crond.patch
Patch15: vixie-cron-4.1-_15_system_crontab_user.patch
Patch16: vixie-cron-4.1-_16_crontab_selinux.patch
Patch17: vixie-cron-4.1-_17_pam-rootok.patch
Patch18: vixie-cron-4.1-_18_cron_log_facility.patch
Patch19: vixie-cron-4.1-_19_crontab_stat_not_fstat.patch
Patch20: vixie-cron-4.1-_20_nickname_man.patch
Patch21: vixie-cron-4.1-_21_-i_option.patch
Patch22: vixie-cron-4.1-_22_no_0600_mode_enforce.patch
Patch23: vixie-cron-4.1-_23_freecon_segv.patch
Patch24: vixie-cron-4.1-_24_crontab_selinux_new.patch
Patch25: vixie-cron-4.1-_25-allow-root-crontab.patch
Patch26: vixie-cron-4.1-_26-saved-uids.patch
Patch27: vixie-cron-4.1-_27-no-strip-header-comments.patch
Patch28: vixie-cron-4.1-_28-fix_ppc.patch
Patch29: vixie-cron-4.1-_29-permit_any_crontab_option.patch
Patch30: vixie-cron-4.1-_30-uninitialized.patch
Patch31: vixie-cron-4.1-_31-allow_pam_access.patch
Patch32: vixie-cron-4.1-_32-no_mail_rcpt_safe_p.patch
Patch33: vixie-cron-4.1-_33-fix_selinux_segfault.patch
Patch34: vixie-cron-4.1-_34-pam_fail_close_session.patch
Patch35: vixie-cron-4.1-_35-crontab-job-control.patch
Patch36: vixie-cron-4.1-_36-pam_close_fork_fail.patch
Patch37: vixie-cron-4.1-_37-limits.patch
Patch38: vixie-cron-4.1-_38-CAN-2005-1038.patch
Patch39: vixie-cron-4.1-loginuid.patch
Patch40: vixie_cron-4.1-162887.patch
Patch41: vixie-cron-4.1-CAN-2005-1038-fix-race.patch
Patch42: vixie-cron-4.1-_42-getseuserbyname.patch
Patch43: vixie-cron-4.1-_43-config_comments.patch
Patch44: vixie-cron-4.1-_44-build_env.patch
Patch45: vixie-cron-4.1-_45-warnings.patch
Patch46: vixie-cron-4.1-_46-audit.patch
Patch47: vixie-cron-4.1-_47-m_option.patch
Patch48: vixie-cron-4.1-_48-security.patch
Patch49: vixie-cron-4.1-_49-bz178436.patch
Patch50: vixie-cron-4.1-_50-bz178931.patch
Patch51: vixie-cron-4.1-_51-bz180145-mail_i18n.patch
Patch52: vixie-cron-4.1-_52-bz181439.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: sysklogd >= 1.4.1-13m, bash >= 2.0
%if %{WITH_SELINUX}
Requires: libselinux
Buildrequires: libselinux-devel
%endif
%if %{WITH_PAM}
Requires: pam
Buildrequires: pam-devel
%endif
%if %{WITH_AUDIT}
Requires: audit-libs
Buildrequires: audit-libs
%endif

PreReq: chkconfig, initscripts, fileutils

%description
The vixie-cron package contains the Vixie version of cron.  Cron is a
standard UNIX daemon that runs specified programs at scheduled times.
Vixie cron adds better security and more powerful configuration
options to the standard version of cron.

%prep
%setup -q
%patch0 -p1 -b .rh_Makefile
%patch1 -p1 -b .rh_pathnames
%patch2 -p1 -b .config
%patch3 -p1 -b .selinux
%patch4 -p1 -b .vfork_sigchld
%patch5 -p1 -b .sprintf_misc
%patch6 -p1 -b .rh_crond
%patch7 -p1 -b .crontab-stdin
%patch8 -p1 -b .root-allowed
%patch9 -p1 -b .no-header
%patch10 -p1 -b .manpages
#%if %{WITH_SELINUX}
#SELinux
# Enables SELinux support
%patch11 -p1 -b .with_selinux
#%endif
%patch12 -p1 -b .pam
#%if %{WITH_PAM}
%patch13 -p1 -b .with_pam
%patch14 -p1 -b .pamd_crond
%patch15 -p1 -b .system_crontab_user
#%endif
%patch16 -p1 -b .crontab_selinux
%patch17 -p1 -b .pam-rootok
%patch18 -p1 -b .cron_log_facility
%patch19 -p1 -b .crontab_stat_not_fstat
%patch20 -p1 -b .nickname_man
%patch21 -p1 -b -i_option
%patch22 -p1 -b .no_0600_mode_enforce
#%if %{WITH_SELINUX}
%patch23 -p1 -b .freecon_segv
%patch24 -p1 -b .selinux_crontab_new
#%endif
%patch25 -p1 -b .allow-root-crontab
%patch26 -p1 -b .saved_uids
%patch27 -p1 -b .no-strip-header-comments
%patch28 -p1 -b .fix_ppc
%patch29 -p1 -b .permit_any_crontab_option
%patch30 -p1 -b .uninitialized
%patch31 -p1 -b .allow_pam_access
%patch32 -p1 -b .no_mail_rcpt_safe_p
%patch33 -p1 -b .fix_selinux_segfault
%patch34 -p1 -b .pam_fail_close_session
%patch35 -p1 -b .job_control
%patch36 -p1 -b .pam_close_fork_fail
%patch37 -p1 -b .limits
%patch38 -p1 -b .CAN-2005-1038
%patch39 -p1 -b .loginuid
%patch40 -p1 -b .162887
%patch41 -p1 -b .CAN-2005-1038-fix-race
%patch42 -p1 -b .getseuserbyname
%patch43 -p1 -b .config_comments
%patch44 -p1 -b .build_env
%patch45 -p1 -b .warnings
%patch46 -p1 -b .audit_deny
%patch47 -p1 -b .-m_option
%patch48 -p1 -b .security
%patch49 -p1 -b .bz178436
%patch50 -p1 -b .bz178931
%patch51 -p1 -b .mail_i18n
%patch52 -p1 -b .bz181439

%build
make RPM_OPT_FLAGS="%{optflags} -g -DLINT -Dlint -Werror" \
%if %{WITH_SELINUX}
WITH_SELINUX=1 \
%endif
%if %{WITH_PAM}
WITH_PAM=1 \
%endif
%if %{WITH_AUDIT}
WITH_AUDIT=1 \
%endif
;

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/{bin,sbin}
mkdir -p %{buildroot}%{_mandir}/man{1,5,8}
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}/etc/pam.d
make install DESTDIR=%{buildroot} DESTMAN=%{buildroot}%{_mandir}
mkdir -p %{buildroot}/var/spool/cron
chmod 700 %{buildroot}/var/spool/cron
mkdir -p %{buildroot}/etc/cron.d
chmod 755 %{buildroot}/etc/cron.d
install -m755 $RPM_SOURCE_DIR/vixie-cron.init %{buildroot}%{_initscriptdir}/crond
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/
cp %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/crond

%clean
rm -rf %{buildroot}

%post
/sbin/chkconfig --add crond
[ ! -f /etc/cron.allow ] && [ ! -f /etc/cron.deny ] && touch /etc/cron.deny ||:;

%preun
if [ "$1" = 0 ]; then
    [ -f /var/lock/subsys/crond ] && /sbin/service crond stop >/dev/null 2>&1
    /sbin/chkconfig --del crond
fi

%postun
if [ "$1" -ge "1" ]; then
        /sbin/service crond condrestart >/dev/null 2>&1
fi

%triggerpostun -- vixie-cron < 3.0.1-48k
/sbin/chkconfig --del crond
/sbin/chkconfig --add crond

%files

%defattr(-,root,root)
/usr/sbin/crond
%attr(6755,root,root) /usr/bin/crontab
%{_mandir}/man8/crond.*
%{_mandir}/man8/cron.*
%{_mandir}/man5/crontab.*
%{_mandir}/man1/crontab.*
%dir /var/spool/cron
%dir /etc/cron.d
%config %{_initscriptdir}/crond
%config /etc/pam.d/crond
%config(noreplace) /etc/sysconfig/crond

%changelog
* Sun May 14 2006 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (4.1-4m)
- sync with fc-devel (4.1-54.FC5)

* Tue Nov 1 2005 Shigeru Yamazaki <muradaikan@momonga-linux.org>
-  (4.1-3m)
- rebuild against libselinux-1.26

* Wed Apr 20 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (4.1-2m)
- sync with Fedora
- [SECURITY] CAN-20051038

* Sun Feb 13 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (4.1-1m)
- import from FC3

* Sat Oct 25 2003 Ryu SASAOKA <ryu@momonga-linux.org>
- (3.0.1-59m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Mon Apr 30 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (3.0.1-58k)
- Prereq: /sbin/chkconfig -> chkconfig
- Prereq: /sbin/service   -> initscripts

* Wed Feb 20 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.0.1-56k)
- removed Source0 statement.

* Sat Oct 27 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.1-54k)
- modify %post section robust

* Wed Jun 20 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (3.0.1-52k)
- fixed path /usr/bin/vi to /bin/vi (vixie-cron-toriaezu.patch)

* Tue Mar  6 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.1-50k)
- import 3.0.1-62 from RHL for security fix

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Wed Jul 05 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.

* Sat Apr 08 2000 Takaaki Tabuchi <tab@kondara.org>
- merge redhat-6.2 (3.0.1-40).

* Thu Feb  3 2000 Bill Nottingham <notting@redhat.com>
- handle compressed man pages

* Mon Jan 17 2000 Takaaki Tabuchi <tab@kondara.org>
- be able to rebuild non-root user.

* Sun Nov 7 1999 Toru Hoshina <t@kondara.org>
- be a NoSrc :-P

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Wed Aug 25 1999 Bill Nottingham <notting@redhat.com>
- fix buffer overflow

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Fri Jul 30 1999 Michael K. Johnson <johnsonm@redhat.com>
- dayofmonth and month can't be 0

* Thu Jun  3 1999 Jeff Johnson <jbj@redhat.com>
- in cron.log use "kill -HUP pid" not killall to preserve errors (#2241).

* Wed Apr 14 1999 Michael K. Johnson <johnsonm@redhat.com>
- add note to man page about DST conversion causing strangeness
- documented cron.d patch

* Tue Apr 13 1999 Michael K. Johnson <johnsonm@redhat.com>
- improved cron.d patch

* Mon Apr 12 1999 Erik Troan <ewt@redhat.com>
- added cron.d patch

* Tue Mar 23 1999 Bill Nottingham <notting@redhat.com>
- logrotate changes

* Tue Mar 23 1999 Preston Brown <pbrown@redhat.com>
- clean up log files on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 28)

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- build for glibc 2.1

* Wed Jun 10 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- reset SIGCHLD before grandchild execle (problem #732)

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- enhanced initscript

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Dec 11 1997 Cristian Gafton <gafton@redhat.com>
- added a patch to get rid of the dangerous sprintf() calls
- added BuildRoot and Prereq: /sbin/chkconfig

* Sun Nov 09 1997 Michael K. Johnson <johnsonm@redhat.com>
- fixed cron/crond dichotomy in init file.

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- fixed bad init symlinks

* Thu Oct 23 1997 Erik Troan <ewt@redhat.com>
- force it to use SIGCHLD instead of defunct SIGCLD

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- updated for chkconfig
- added status, restart options to init script

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Wed Feb 19 1997 Erik Troan <ewt@redhat.com>
- Switch conditional from "axp" to "alpha" 

